blob: 578780be138b216dc89333e1fde87ddcb91e5e54 [file] [log] [blame]
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -07001#!/bin/sh
2#
Junio C Hamanod64e6b02006-02-18 20:51:26 -08003# Copyright (c) 2005, 2006 Junio C Hamano
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -07004
Jeff Kingc1491842008-03-01 01:22:55 -05005SUBDIRECTORY_OK=Yes
Pierre Habouzit78443d92007-11-04 11:30:57 +01006OPTIONS_KEEPDASHDASH=
7OPTIONS_SPEC="\
Junio C Hamano588c0382008-07-16 17:22:50 -07008git am [options] [<mbox>|<Maildir>...]
Stephan Beyer09f8d052008-07-25 20:22:23 +02009git am [options] (--resolved | --skip | --abort)
Pierre Habouzit78443d92007-11-04 11:30:57 +010010--
Junio C Hamano66006c62007-11-08 23:04:31 -080011i,interactive run interactively
Jay Soffian98ef23b2009-01-28 10:03:10 -050012b,binary* (historical option -- no-op)
Pierre Habouzit78443d92007-11-04 11:30:57 +0100133,3way allow fall back on 3way merging if needed
14s,signoff add a Signed-off-by line to the commit message
15u,utf8 recode into utf8 (default)
Jörg Sommerfe1fa942008-02-03 00:58:06 +010016k,keep pass -k flag to git-mailinfo
Pierre Habouzit78443d92007-11-04 11:30:57 +010017whitespace= pass it through git-apply
Junio C Hamanob47dfe92009-01-11 22:21:48 -080018directory= pass it through git-apply
Pierre Habouzit78443d92007-11-04 11:30:57 +010019C= pass it through git-apply
20p= pass it through git-apply
martin f. krafftb80da422009-01-23 11:31:21 +110021reject pass it through git-apply
Pierre Habouzit78443d92007-11-04 11:30:57 +010022resolvemsg= override error message when patch failure occurs
23r,resolved to be used after a patch failure
Junio C Hamano3041c322008-03-04 00:25:06 -080024skip skip the current patch
Nanako Shiraishi3e5057a2008-07-16 19:39:10 +090025abort restore the original branch and abort the patching operation.
Junio C Hamano3f01ad62009-01-22 16:14:58 -080026committer-date-is-author-date lie about committer date
Nanako Shiraishia79ec622009-01-24 10:18:02 +090027ignore-date use current timestamp for author date
Jay Soffian98ef23b2009-01-28 10:03:10 -050028rebasing* (internal use for git-rebase)"
Pierre Habouzit78443d92007-11-04 11:30:57 +010029
freku045@student.liu.secf1fe882005-12-13 23:30:31 +010030. git-sh-setup
Junio C Hamanobb034f82008-03-04 00:25:04 -080031prefix=$(git rev-parse --show-prefix)
Shawn O. Pearcef9474132006-12-28 02:34:48 -050032set_reflog_action am
Shawn O. Pearce7eff28a2006-12-30 23:32:38 -050033require_work_tree
Jeff Kingc1491842008-03-01 01:22:55 -050034cd_to_toplevel
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -070035
Stephan Beyer460abee2008-07-12 17:46:59 +020036git var GIT_COMMITTER_IDENT >/dev/null ||
37 die "You need to set your committer info first"
Junio C Hamanod64e6b02006-02-18 20:51:26 -080038
Nanako Shiraishif79d4c82009-04-10 09:34:42 +090039if git rev-parse --verify -q HEAD >/dev/null
40then
41 HAS_HEAD=yes
42else
43 HAS_HEAD=
44fi
45
Junio C Hamanob47dfe92009-01-11 22:21:48 -080046sq () {
Christian Couder47c97392009-04-24 08:29:01 +020047 git rev-parse --sq-quote "$@"
Junio C Hamanob47dfe92009-01-11 22:21:48 -080048}
49
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -070050stop_here () {
51 echo "$1" >"$dotest/next"
52 exit 1
53}
54
Robert Shearmanced94562006-05-02 13:32:43 +010055stop_here_user_resolve () {
Seancc120052006-05-13 23:34:08 -040056 if [ -n "$resolvemsg" ]; then
Jeff Kinga23bfae2007-05-26 00:33:03 -070057 printf '%s\n' "$resolvemsg"
Seancc120052006-05-13 23:34:08 -040058 stop_here $1
59 fi
Olivier Marin75e16452008-07-21 16:12:20 +020060 cmdline="git am"
Robert Shearmanced94562006-05-02 13:32:43 +010061 if test '' != "$interactive"
62 then
63 cmdline="$cmdline -i"
64 fi
65 if test '' != "$threeway"
66 then
67 cmdline="$cmdline -3"
68 fi
Robert Shearmanced94562006-05-02 13:32:43 +010069 echo "When you have resolved this problem run \"$cmdline --resolved\"."
70 echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
Nanako Shiraishi3e5057a2008-07-16 19:39:10 +090071 echo "To restore the original branch and stop patching run \"$cmdline --abort\"."
Robert Shearmanced94562006-05-02 13:32:43 +010072
73 stop_here $1
74}
75
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -070076go_next () {
77 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
78 "$dotest/patch" "$dotest/info"
79 echo "$next" >"$dotest/next"
80 this=$next
81}
82
Junio C Hamanofd7bcfb2006-08-12 16:16:47 -070083cannot_fallback () {
84 echo "$1"
85 echo "Cannot fall back to three-way merge."
86 exit 1
87}
88
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -070089fall_back_3way () {
90 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
91
92 rm -fr "$dotest"/patch-merge-*
93 mkdir "$dotest/patch-merge-tmp-dir"
94
95 # First see if the patch records the index info that we can use.
Johannes Schindelin7a988692007-09-17 23:34:06 +010096 git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
97 "$dotest/patch" &&
Junio C Hamanofd7bcfb2006-08-12 16:16:47 -070098 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
Junio C Hamano5be60072007-07-02 22:52:14 -070099 git write-tree >"$dotest/patch-merge-base+" ||
Junio C Hamanob1440cc2007-02-24 01:05:27 -0800100 cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
Junio C Hamanofd7bcfb2006-08-12 16:16:47 -0700101
102 echo Using index info to reconstruct a base tree...
103 if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
Stephan Beyercb3a1602008-08-09 01:28:54 +0200104 git apply --cached <"$dotest/patch"
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700105 then
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700106 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
107 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
Junio C Hamanofd7bcfb2006-08-12 16:16:47 -0700108 else
109 cannot_fallback "Did you hand edit your patch?
110It does not apply to blobs recorded in its index."
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700111 fi
112
113 test -f "$dotest/patch-merge-index" &&
Junio C Hamano5be60072007-07-02 22:52:14 -0700114 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700115 orig_tree=$(cat "$dotest/patch-merge-base") &&
116 rm -fr "$dotest"/patch-merge-* || exit 1
117
118 echo Falling back to patching base and 3-way merge...
119
120 # This is not so wrong. Depending on which base we picked,
121 # orig_tree may be wildly different from ours, but his_tree
122 # has the same set of wildly different changes in parts the
Shawn O. Pearce579c9bb2006-12-28 02:35:27 -0500123 # patch did not touch, so recursive ends up canceling them,
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700124 # saying that we reverted all those changes.
125
Linus Torvalds2e6e3e8292008-04-15 12:56:50 -0700126 eval GITHEAD_$his_tree='"$FIRSTLINE"'
Shawn O. Pearce579c9bb2006-12-28 02:35:27 -0500127 export GITHEAD_$his_tree
128 git-merge-recursive $orig_tree -- HEAD $his_tree || {
Johannes Schindelinb4372ef2007-07-06 13:05:59 +0100129 git rerere
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700130 echo Failed to merge in the changes.
131 exit 1
132 }
Shawn O. Pearce579c9bb2006-12-28 02:35:27 -0500133 unset GITHEAD_$his_tree
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700134}
135
136prec=4
Johannes Schindelin51ef1da2008-07-21 12:51:02 +0200137dotest="$GIT_DIR/rebase-apply"
Junio C Hamanoa2003372008-12-04 15:38:27 -0800138sign= utf8=t keep= skip= interactive= resolved= rebasing= abort=
Gerrit Pape3f0a8f32007-08-06 14:15:30 +0000139resolvemsg= resume=
Michael S. Tsirkin67dad682007-02-08 15:57:08 +0200140git_apply_opt=
Junio C Hamano3f01ad62009-01-22 16:14:58 -0800141committer_date_is_author_date=
Nanako Shiraishia79ec622009-01-24 10:18:02 +0900142ignore_date=
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700143
David Kastrup822f7c72007-09-23 22:42:08 +0200144while test $# != 0
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700145do
146 case "$1" in
Pierre Habouzit78443d92007-11-04 11:30:57 +0100147 -i|--interactive)
148 interactive=t ;;
149 -b|--binary)
Stephan Beyercb3a1602008-08-09 01:28:54 +0200150 : ;;
Pierre Habouzit78443d92007-11-04 11:30:57 +0100151 -3|--3way)
152 threeway=t ;;
Johannes Sixtdfdd7e62007-11-06 21:33:58 +0100153 -s|--signoff)
Pierre Habouzit78443d92007-11-04 11:30:57 +0100154 sign=t ;;
155 -u|--utf8)
156 utf8=t ;; # this is now default
157 --no-utf8)
158 utf8= ;;
159 -k|--keep)
160 keep=t ;;
161 -r|--resolved)
162 resolved=t ;;
163 --skip)
164 skip=t ;;
Nanako Shiraishi3e5057a2008-07-16 19:39:10 +0900165 --abort)
166 abort=t ;;
Junio C Hamano3041c322008-03-04 00:25:06 -0800167 --rebasing)
Stephan Beyercb3a1602008-08-09 01:28:54 +0200168 rebasing=t threeway=t keep=t ;;
Pierre Habouzit78443d92007-11-04 11:30:57 +0100169 -d|--dotest)
Junio C Hamanoe72c7402008-03-04 00:25:05 -0800170 die "-d option is no longer supported. Do not use."
171 ;;
Pierre Habouzit78443d92007-11-04 11:30:57 +0100172 --resolvemsg)
173 shift; resolvemsg=$1 ;;
Junio C Hamanob47dfe92009-01-11 22:21:48 -0800174 --whitespace|--directory)
175 git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
Pierre Habouzit78443d92007-11-04 11:30:57 +0100176 -C|-p)
Junio C Hamanob47dfe92009-01-11 22:21:48 -0800177 git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
martin f. krafftb80da422009-01-23 11:31:21 +1100178 --reject)
179 git_apply_opt="$git_apply_opt $1" ;;
Junio C Hamano3f01ad62009-01-22 16:14:58 -0800180 --committer-date-is-author-date)
181 committer_date_is_author_date=t ;;
Nanako Shiraishia79ec622009-01-24 10:18:02 +0900182 --ignore-date)
183 ignore_date=t ;;
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700184 --)
Pierre Habouzit78443d92007-11-04 11:30:57 +0100185 shift; break ;;
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700186 *)
Pierre Habouzit78443d92007-11-04 11:30:57 +0100187 usage ;;
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700188 esac
Pierre Habouzit78443d92007-11-04 11:30:57 +0100189 shift
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700190done
191
Junio C Hamano0c15cc92005-11-16 00:19:32 -0800192# If the dotest directory exists, but we have finished applying all the
193# patches in them, clear it out.
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700194if test -d "$dotest" &&
195 last=$(cat "$dotest/last") &&
196 next=$(cat "$dotest/next") &&
197 test $# != 0 &&
198 test "$next" -gt "$last"
199then
200 rm -fr "$dotest"
201fi
202
203if test -d "$dotest"
204then
Nanako Shiraishi3e5057a2008-07-16 19:39:10 +0900205 case "$#,$skip$resolved$abort" in
Junio C Hamanoc95b1382006-09-15 23:19:02 -0700206 0,*t*)
207 # Explicit resume command and we do not have file, so
208 # we are happy.
209 : ;;
210 0,)
211 # No file input but without resume parameters; catch
212 # user error to feed us a patch from standard input
Junio C Hamanoe72c7402008-03-04 00:25:05 -0800213 # when there is already $dotest. This is somewhat
Junio C Hamanoc95b1382006-09-15 23:19:02 -0700214 # unreliable -- stdin could be /dev/null for example
215 # and the caller did not intend to feed us a patch but
216 # wanted to continue unattended.
Jay Soffian98ef23b2009-01-28 10:03:10 -0500217 test -t 0
Junio C Hamanoc95b1382006-09-15 23:19:02 -0700218 ;;
219 *)
220 false
221 ;;
222 esac ||
Johannes Schindelin28ed6e72008-07-16 03:33:44 +0200223 die "previous rebase directory $dotest still exists but mbox given."
Junio C Hamano271440e2005-10-25 23:35:37 -0700224 resume=yes
Nanako Shiraishi3e5057a2008-07-16 19:39:10 +0900225
Olivier Marin95f8ebb2008-07-21 15:39:06 +0200226 case "$skip,$abort" in
Junio C Hamano2d56a132009-02-26 11:24:29 -0800227 t,t)
228 die "Please make up your mind. --skip or --abort?"
229 ;;
Olivier Marin95f8ebb2008-07-21 15:39:06 +0200230 t,)
231 git rerere clear
232 git read-tree --reset -u HEAD HEAD
233 orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
234 git reset HEAD
235 git update-ref ORIG_HEAD $orig_head
236 ;;
237 ,t)
Junio C Hamano2d56a132009-02-26 11:24:29 -0800238 if test -f "$dotest/rebasing"
239 then
240 exec git rebase --abort
241 fi
Nanako Shiraishi3e5057a2008-07-16 19:39:10 +0900242 git rerere clear
Michael J Gruberc7671842009-02-26 10:52:53 +0100243 test -f "$dotest/dirtyindex" || {
244 git read-tree --reset -u HEAD ORIG_HEAD
245 git reset ORIG_HEAD
246 }
Nanako Shiraishi3e5057a2008-07-16 19:39:10 +0900247 rm -fr "$dotest"
248 exit ;;
249 esac
Michael J Gruberc7671842009-02-26 10:52:53 +0100250 rm -f "$dotest/dirtyindex"
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700251else
Nanako Shiraishi3e5057a2008-07-16 19:39:10 +0900252 # Make sure we are not given --skip, --resolved, nor --abort
253 test "$skip$resolved$abort" = "" ||
Seancc120052006-05-13 23:34:08 -0400254 die "Resolve operation not in progress, we are not resuming."
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700255
256 # Start afresh.
257 mkdir -p "$dotest" || exit
258
Junio C Hamanobb034f82008-03-04 00:25:04 -0800259 if test -n "$prefix" && test $# != 0
260 then
261 first=t
262 for arg
263 do
264 test -n "$first" && {
265 set x
266 first=
267 }
268 case "$arg" in
269 /*)
270 set "$@" "$arg" ;;
271 *)
272 set "$@" "$prefix$arg" ;;
273 esac
274 done
275 shift
276 fi
Junio C Hamano5be60072007-07-02 22:52:14 -0700277 git mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" || {
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700278 rm -fr "$dotest"
279 exit 1
280 }
281
Junio C Hamano22db2402008-12-04 15:38:27 -0800282 # -s, -u, -k, --whitespace, -3, -C and -p flags are kept
Junio C Hamanoa2003372008-12-04 15:38:27 -0800283 # for the resuming session after a patch failure.
Junio C Hamano22db2402008-12-04 15:38:27 -0800284 # -i can and must be given when resuming.
Junio C Hamano9b9f5a22008-12-05 11:19:43 -0800285 echo " $git_apply_opt" >"$dotest/apply-opt"
Junio C Hamano22db2402008-12-04 15:38:27 -0800286 echo "$threeway" >"$dotest/threeway"
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700287 echo "$sign" >"$dotest/sign"
288 echo "$utf8" >"$dotest/utf8"
289 echo "$keep" >"$dotest/keep"
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700290 echo 1 >"$dotest/next"
Junio C Hamano3041c322008-03-04 00:25:06 -0800291 if test -n "$rebasing"
292 then
293 : >"$dotest/rebasing"
294 else
295 : >"$dotest/applying"
Nanako Shiraishif79d4c82009-04-10 09:34:42 +0900296 if test -n "$HAS_HEAD"
297 then
298 git update-ref ORIG_HEAD HEAD
299 else
300 git update-ref -d ORIG_HEAD >/dev/null 2>&1
301 fi
Junio C Hamano3041c322008-03-04 00:25:06 -0800302 fi
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700303fi
304
Junio C Hamano0c15cc92005-11-16 00:19:32 -0800305case "$resolved" in
306'')
Nanako Shiraishif79d4c82009-04-10 09:34:42 +0900307 case "$HAS_HEAD" in
308 '')
309 files=$(git ls-files) ;;
310 ?*)
311 files=$(git diff-index --cached --name-only HEAD --) ;;
312 esac || exit
Michael J Gruberc7671842009-02-26 10:52:53 +0100313 if test "$files"
314 then
Nanako Shiraishif79d4c82009-04-10 09:34:42 +0900315 test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
Michael J Gruberc7671842009-02-26 10:52:53 +0100316 die "Dirty index: cannot apply patches (dirty: $files)"
317 fi
Junio C Hamano0c15cc92005-11-16 00:19:32 -0800318esac
319
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700320if test "$(cat "$dotest/utf8")" = t
321then
322 utf8=-u
Junio C Hamanobb1091a2007-01-09 21:31:36 -0800323else
324 utf8=-n
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700325fi
326if test "$(cat "$dotest/keep")" = t
327then
328 keep=-k
329fi
Junio C Hamano22db2402008-12-04 15:38:27 -0800330if test "$(cat "$dotest/threeway")" = t
331then
332 threeway=t
333fi
Junio C Hamano9b9f5a22008-12-05 11:19:43 -0800334git_apply_opt=$(cat "$dotest/apply-opt")
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700335if test "$(cat "$dotest/sign")" = t
336then
Todd Zullinger5354a562008-07-30 13:48:33 -0400337 SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700338 s/>.*/>/
339 s/^/Signed-off-by: /'
340 `
341else
342 SIGNOFF=
343fi
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700344
345last=`cat "$dotest/last"`
346this=`cat "$dotest/next"`
347if test "$skip" = t
348then
349 this=`expr "$this" + 1`
Jan Harkes69224712005-12-17 01:01:06 -0500350 resume=
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700351fi
352
353if test "$this" -gt "$last"
354then
355 echo Nothing to do.
356 rm -fr "$dotest"
357 exit
358fi
359
360while test "$this" -le "$last"
361do
362 msgnum=`printf "%0${prec}d" $this`
363 next=`expr "$this" + 1`
364 test -f "$dotest/$msgnum" || {
Jan Harkes69224712005-12-17 01:01:06 -0500365 resume=
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700366 go_next
367 continue
368 }
Junio C Hamano0c15cc92005-11-16 00:19:32 -0800369
370 # If we are not resuming, parse and extract the patch information
371 # into separate files:
372 # - info records the authorship and title
373 # - msg is the rest of commit log message
374 # - patch is the patch body.
375 #
376 # When we are resuming, these files are either already prepared
377 # by the user, or the user can tell us to do so by --resolved flag.
Junio C Hamano271440e2005-10-25 23:35:37 -0700378 case "$resume" in
379 '')
Junio C Hamano5be60072007-07-02 22:52:14 -0700380 git mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
Junio C Hamano271440e2005-10-25 23:35:37 -0700381 <"$dotest/$msgnum" >"$dotest/info" ||
382 stop_here $this
Johannes Schindelinca193cf2007-07-24 01:02:25 +0100383
384 # skip pine's internal folder data
385 grep '^Author: Mail System Internal Data$' \
386 <"$dotest"/info >/dev/null &&
387 go_next && continue
388
Johannes Schindelin28ed6e72008-07-16 03:33:44 +0200389 test -s "$dotest/patch" || {
Josh Triplett6777c382007-04-23 17:32:04 -0700390 echo "Patch is empty. Was it split wrong?"
Don Zickus87ab7992007-03-12 15:52:04 -0400391 stop_here $this
392 }
Junio C Hamano5e835ca2008-04-16 12:50:48 -0700393 if test -f "$dotest/rebasing" &&
394 commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
395 -e q "$dotest/$msgnum") &&
396 test "$(git cat-file -t "$commit")" = commit
397 then
398 git cat-file commit "$commit" |
399 sed -e '1,/^$/d' >"$dotest/msg-clean"
400 else
401 SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
402 case "$keep_subject" in -k) SUBJECT="[PATCH] $SUBJECT" ;; esac
Linus Torvalds2e6e3e8292008-04-15 12:56:50 -0700403
Junio C Hamano41a3e3a2008-04-19 23:01:51 -0700404 (printf '%s\n\n' "$SUBJECT"; cat "$dotest/msg") |
Junio C Hamano5e835ca2008-04-16 12:50:48 -0700405 git stripspace > "$dotest/msg-clean"
406 fi
Junio C Hamano271440e2005-10-25 23:35:37 -0700407 ;;
408 esac
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700409
410 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
411 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
412 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
Junio C Hamanoe0e3ba22005-12-14 16:31:06 -0800413
Junio C Hamano3b789592007-12-05 13:16:35 -0800414 if test -z "$GIT_AUTHOR_EMAIL"
Junio C Hamanoe0e3ba22005-12-14 16:31:06 -0800415 then
Junio C Hamano3b789592007-12-05 13:16:35 -0800416 echo "Patch does not have a valid e-mail address."
Junio C Hamanoe0e3ba22005-12-14 16:31:06 -0800417 stop_here $this
418 fi
419
Junio C Hamano2c674192005-10-20 22:31:56 -0700420 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700421
Junio C Hamano4bfb6b62005-11-08 00:41:37 -0800422 case "$resume" in
423 '')
424 if test '' != "$SIGNOFF"
425 then
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700426 LAST_SIGNED_OFF_BY=`
Junio C Hamano4bfb6b62005-11-08 00:41:37 -0800427 sed -ne '/^Signed-off-by: /p' \
428 "$dotest/msg-clean" |
Jeff Kingb4ce54f2008-03-12 17:34:34 -0400429 sed -ne '$p'
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700430 `
Junio C Hamano4bfb6b62005-11-08 00:41:37 -0800431 ADD_SIGNOFF=`
432 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700433 test '' = "$LAST_SIGNED_OFF_BY" && echo
434 echo "$SIGNOFF"
Junio C Hamano4bfb6b62005-11-08 00:41:37 -0800435 }`
436 else
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700437 ADD_SIGNOFF=
Junio C Hamano4bfb6b62005-11-08 00:41:37 -0800438 fi
439 {
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700440 if test -s "$dotest/msg-clean"
441 then
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700442 cat "$dotest/msg-clean"
443 fi
444 if test '' != "$ADD_SIGNOFF"
445 then
446 echo "$ADD_SIGNOFF"
447 fi
Junio C Hamano4bfb6b62005-11-08 00:41:37 -0800448 } >"$dotest/final-commit"
449 ;;
Junio C Hamano0c15cc92005-11-16 00:19:32 -0800450 *)
Junio C Hamano6d286442006-02-23 22:14:47 -0800451 case "$resolved$interactive" in
Junio C Hamano0c15cc92005-11-16 00:19:32 -0800452 tt)
453 # This is used only for interactive view option.
Junio C Hamano38762c42007-11-28 16:15:04 -0800454 git diff-index -p --cached HEAD -- >"$dotest/patch"
Junio C Hamano0c15cc92005-11-16 00:19:32 -0800455 ;;
456 esac
Junio C Hamano4bfb6b62005-11-08 00:41:37 -0800457 esac
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700458
Junio C Hamano4bfb6b62005-11-08 00:41:37 -0800459 resume=
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700460 if test "$interactive" = t
461 then
Junio C Hamanoa1451102005-10-12 18:31:41 -0700462 test -t 0 ||
463 die "cannot be interactive without stdin connected to a terminal."
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700464 action=again
465 while test "$action" = again
466 do
467 echo "Commit Body is:"
468 echo "--------------------------"
469 cat "$dotest/final-commit"
470 echo "--------------------------"
Jason Riedy97545632005-12-06 14:21:52 -0800471 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700472 read reply
473 case "$reply" in
Junio C Hamanof89ad672005-10-25 23:43:59 -0700474 [yY]*) action=yes ;;
475 [aA]*) action=yes interactive= ;;
476 [nN]*) action=skip ;;
Adam Robenef0c2ab2007-07-19 22:09:35 -0700477 [eE]*) git_editor "$dotest/final-commit"
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700478 action=again ;;
Junio C Hamanof89ad672005-10-25 23:43:59 -0700479 [vV]*) action=again
480 LESS=-S ${PAGER:-less} "$dotest/patch" ;;
481 *) action=again ;;
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700482 esac
483 done
484 else
485 action=yes
486 fi
Alejandro Mery1d9b2652008-06-17 13:43:57 +0200487 FIRSTLINE=$(sed 1q "$dotest/final-commit")
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700488
489 if test $action = skip
490 then
491 go_next
492 continue
493 fi
494
495 if test -x "$GIT_DIR"/hooks/applypatch-msg
496 then
497 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
498 stop_here $this
499 fi
500
Stephan Beyerc8fe1982008-07-23 18:46:36 +0200501 printf 'Applying: %s\n' "$FIRSTLINE"
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700502
Junio C Hamano0c15cc92005-11-16 00:19:32 -0800503 case "$resolved" in
504 '')
Junio C Hamanob47dfe92009-01-11 22:21:48 -0800505 eval 'git apply '"$git_apply_opt"' --index "$dotest/patch"'
Junio C Hamano0c15cc92005-11-16 00:19:32 -0800506 apply_status=$?
507 ;;
508 t)
509 # Resolved means the user did all the hard work, and
510 # we do not have to do any patch application. Just
511 # trust what the user has in the index file and the
512 # working tree.
513 resolved=
Junio C Hamano38762c42007-11-28 16:15:04 -0800514 git diff-index --quiet --cached HEAD -- && {
Shawn O. Pearce64646d12006-12-21 21:30:17 -0500515 echo "No changes - did you forget to use 'git add'?"
Robert Shearmanced94562006-05-02 13:32:43 +0100516 stop_here_user_resolve $this
Alex Riesen06aff472007-03-25 01:56:13 +0100517 }
Junio C Hamano5be60072007-07-02 22:52:14 -0700518 unmerged=$(git ls-files -u)
Junio C Hamanoc1d11282006-04-28 02:32:44 -0700519 if test -n "$unmerged"
520 then
521 echo "You still have unmerged paths in your index"
Shawn O. Pearce64646d12006-12-21 21:30:17 -0500522 echo "did you forget to use 'git add'?"
Robert Shearmanced94562006-05-02 13:32:43 +0100523 stop_here_user_resolve $this
Junio C Hamanoc1d11282006-04-28 02:32:44 -0700524 fi
Junio C Hamano0c15cc92005-11-16 00:19:32 -0800525 apply_status=0
Johannes Schindelinb4372ef2007-07-06 13:05:59 +0100526 git rerere
Junio C Hamano0c15cc92005-11-16 00:19:32 -0800527 ;;
528 esac
529
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700530 if test $apply_status = 1 && test "$threeway" = t
531 then
Junio C Hamano73319032005-10-13 11:46:43 -0700532 if (fall_back_3way)
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700533 then
Junio C Hamano73319032005-10-13 11:46:43 -0700534 # Applying the patch to an earlier tree and merging the
535 # result may have produced the same tree as ours.
Junio C Hamano38762c42007-11-28 16:15:04 -0800536 git diff-index --quiet --cached HEAD -- && {
Alex Riesen06aff472007-03-25 01:56:13 +0100537 echo No changes -- Patch already applied.
538 go_next
539 continue
540 }
Junio C Hamano73319032005-10-13 11:46:43 -0700541 # clear apply_status -- we have successfully merged.
542 apply_status=0
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700543 fi
544 fi
545 if test $apply_status != 0
546 then
Junio C Hamano4d2e2832009-01-18 19:34:31 -0800547 printf 'Patch failed at %s %s\n' "$msgnum" "$FIRSTLINE"
Robert Shearmanced94562006-05-02 13:32:43 +0100548 stop_here_user_resolve $this
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700549 fi
550
551 if test -x "$GIT_DIR"/hooks/pre-applypatch
552 then
553 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
554 fi
555
Junio C Hamano5be60072007-07-02 22:52:14 -0700556 tree=$(git write-tree) &&
Junio C Hamano3f01ad62009-01-22 16:14:58 -0800557 commit=$(
Nanako Shiraishia79ec622009-01-24 10:18:02 +0900558 if test -n "$ignore_date"
559 then
560 GIT_AUTHOR_DATE=
561 fi
Nanako Shiraishif79d4c82009-04-10 09:34:42 +0900562 parent=$(git rev-parse --verify -q HEAD) ||
563 echo >&2 "applying to an empty history"
564
Junio C Hamano3f01ad62009-01-22 16:14:58 -0800565 if test -n "$committer_date_is_author_date"
566 then
567 GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
568 export GIT_COMMITTER_DATE
569 fi &&
Ben Jacksonea10b602009-04-18 20:42:07 -0700570 git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
Junio C Hamano3f01ad62009-01-22 16:14:58 -0800571 ) &&
Linus Torvalds2e6e3e8292008-04-15 12:56:50 -0700572 git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700573 stop_here $this
574
575 if test -x "$GIT_DIR"/hooks/post-applypatch
576 then
577 "$GIT_DIR"/hooks/post-applypatch
578 fi
579
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700580 go_next
581done
582
Michael Stefaniuce0cd2522008-01-04 19:59:26 +0100583git gc --auto
584
Junio C Hamanod1c5f2a2005-10-07 03:44:18 -0700585rm -fr "$dotest"